open import Data.Nat
open import Data.Nat.Properties
open import Relation.Binary.PropositionalEquality
open import Div2

open ≡-Reasoning

{-
+-com : (m n : ℕ) → m + n ≡ n + m
+-com zero    n = sym (+-identityʳ n)
+-com (suc m) n = begin
  suc m + n   ≡⟨ refl ⟩
  suc (m + n) ≡⟨ cong suc (+-comm m n) ⟩
  suc (n + m) ≡⟨ sym (+-suc n m) ⟩
  n + suc m  ∎-}


+-com : (m n : ℕ) → m + n ≡ n + m
+-com zero    n = sym (+-identityʳ n)
+-com (suc m) n = begin
  suc m + n   ≡⟨ refl ⟩
  suc (m + n) ≡⟨ cong suc (+-com m n) ⟩
  suc (n + m) ≡⟨ sym (+-suc n m)  ⟩
  n + suc m ∎
  
div2-double : (n : ℕ) → div2 (2 * n) ≡ n
div2-double zero = refl
div2-double (suc n) = begin
  div2 (suc (n + suc (n + zero)))  ≡⟨ cong div2 (cong suc (+-suc n (n + zero))) ⟩
 div2 (suc (suc (n + (n + zero)))) ≡⟨ refl ⟩
 suc (div2 (2 * n))                ≡⟨ cong suc (div2-double n) ⟩
 suc n  ∎

triangular : ℕ → ℕ
triangular zero = zero
triangular (suc n) = suc n + triangular n

div2-+ : (n m : ℕ) → n + div2 m ≡ div2 ((2 * n) + m)
div2-+ zero m = refl
div2-+ (suc n) m = {!!}

{-
Il faut vraiment que j'arrête de procrastiner l'écriture de ma thèse en faisant des 
corrections d'agda, je m'arrête là
-}
{-
mutual
  gauss-suc :  (n : ℕ) → (n + triangular n) ≡ (div2 (n + n * suc (suc n)))
  gauss-suc n = begin
    n + triangular n  ≡⟨ cong (λ x → n + x) (gauss n) ⟩
    n + div2 (n * suc n)  ≡⟨ {!!} ⟩
    div2 (n + n * suc (suc n)) ∎

  gauss : (n : ℕ) → triangular n ≡ div2 (n * suc n)
  gauss zero = refl
  gauss (suc n) = cong suc (gauss-suc n)
-}

